"double.slice" <-
function(y, delta, x, n.slice1, n.slice0){
    "cov1" <-
    function(x, use="pair"){
        n = nrow(x);
        c = cov(x, use=use)*(n-1)/n;
        c
    }
    "slice.idx" <-
    function(y, h, m){
        ly = length(y);
        if(m < max(y) ) {stop("y is not a valid index vector");}
        n1 = ceiling(ly/h);
        n2 = floor(ly/h);
        split = numeric(m);
        if(n1==n2){
            n = ly/h;
            index = rep(n, h);
        }else if(n1 > n2){
            h1 = ly%%h;
            h2 = h - h1;
            index = rep(c(n1, n2), c(h1, h2));
        }
        end = 0;
        for(i in 1:h){
            bgn = end + 1;
            end = end + index[i];
            split[y[bgn:end]] = i;
        }
        split
    }

    # order the data by survival time first
    ordr = order(y, -delta);
    y = y[ordr];
    x = x[ordr,];
    delta = delta[ordr];

    ds.idx = numeric(nrow(x));
    
    y.idx0 = (1:nrow(x))[delta==0];
    y.idx0 = y.idx0[order(y[delta==0])];
    ds.idx0 = slice.idx(y.idx0, n.slice0, nrow(x));

    y.idx1 = (1:nrow(x))[delta==1];
    y.idx1 = y.idx1[order(y[delta==1])];
    ds.idx1 = slice.idx(y.idx1, n.slice1, nrow(x));

    ds.idx[ds.idx0 > 0] = ds.idx0[ds.idx0 > 0];
    ds.idx[ds.idx1 > 0] = ds.idx1[ds.idx1 > 0] + n.slice0;
    
    n.per.slice = as.vector(table(ds.idx));
    probs = n.per.slice/nrow(x);
    
    for(i in 1:length(n.per.slice)){
        x.slice = x[(1:nrow(x))[ds.idx==i],];
        cov.slice = cov1(x.slice, use="pair");
        if(i==1){
            ave.covx = probs[i]*cov.slice;
        }else{
            ave.covx = ave.covx + probs[i]*cov.slice;
        }
    }
    
    sigma.x = cov1(x, use="pair");
    sigma.eta = sigma.x - ave.covx;
    
    eign = eigen.decomp(sigma.eta, sigma.x);
    ordr = order(eign$values, decreasing=TRUE);
    e.val = eign$values[ordr];
    e.vec = eign$vectors[,ordr];
    
    if(is.null(colnames(x))){
       x.names = paste("X", 1:ncol(x), sep="");
    }else{
       x.names = colnames(x);
    }
    dimnames(e.vec) = list(x.names, paste("Dir", 1:ncol(e.vec), sep=""));
    
    n.s = n.slice1 + n.slice0;
    ds = list(y=y, x=x, delta=delta, eval=e.val, evec=e.vec, nslice=n.s);
    ds$nslice0 = n.slice0;
    ds$nslice1 = n.slice1;

    class(ds) = "ds";
    ds
}

