"plot.sir" <-
function(object, which=1:ncol(object$evec), logY=FALSE) {
    if(length(which)>6){
        stop("no more than 6 directions can be plot at one time");
    }
    
    dirs = object$x %*% object$evec[,which];
    if(logY){
        surv = log(object$y);
        labY = "log(survival time)";
    }else{
        surv = object$y;
        labY = "survival time";
    }
    labX = colnames(object$evec)[which];
    
    if(length(which)==2){ par(mfrow=c(1,2)); }
    if(length(which)==3 || length(which)==4){ par(mfrow=c(2,2)); }
    if(length(which)==5 || length(which)==6){ par(mfrow=c(2,3)); }
    
    for(i in 1:length(which)){
        plot(dirs[,i][object$delta==1], surv[object$delta==1], 
            col="blue", type="p", pch=16, 
            xlab=labX[i], ylab=labY, main="", 
            xlim=range(dirs[,i]), ylim=range(surv))
        points(dirs[,i][object$delta==0], surv[object$delta==0], 
            col="red", type="p", pch=10);
        legend(min(dirs[,i]) + 0.05*(max(dirs[,i]) - min(dirs[,i])), 
            min(surv) + 0.95*(max(surv) - min(surv)), 
            legend=c("censored", "uncensored"),  
            col=c("red", "blue"), pch=c(10, 16))
    }
}

"plot.csir" <-
function(object, which=1:ncol(object$evec), logY=FALSE) {
    plot.sir(object, which=which, logY=logY)
}

"plot.ds" <-
function(object, which=1:ncol(object$evec), logY=FALSE) {
    plot.sir(object, which=which, logY=logY)
}

