\name{edr.n}
\alias{edr.n}
\alias{edr.percent}

\title{ get e.d.r. directions }
\description{
  take a csir(result of cen.sir) or ds(result of double.slice) object as input,
  return the effective dimension reduction directions.
}
\usage{
edr.n(object, n)
edr.percent(object, percent)
}
\arguments{
  \item{object}{ a variable of class csir(result of cen.sir) or 
    ds(result of double.slice) }
  \item{n}{ the number of directions to return }
  \item{percent}{ the minimum percentage of information that the returned 
    directions should explain, real number between 0 and 1  }
}
\details{
  \code{edr.n} simply return the first n eigen-vectors of an csir or ds
  object. \code{edr.percent} simply return the first n eigen-vectors that
  explain at least \code{percent} information.
  To decide how many directions should be used, users can read the 
  print-out of a csir or a ds object, where result of Chi-Square test and 
  size of eigen values are shown. 
}
\value{
  a matrix, each column is one eigen-vector to be used.
}
\references{ 
  Ker-chau Li, Jane-ling Wang and Chun-Hou Chen (1999) Dimension reduction for 
  censored regression data.   \emph{The Annals of Statistics} \bold{27}, 1-23.
}
\author{  Wei Sun sunwei@stat.ucla.edu }
\note{ These two functions: \code{edr.n} and \code{edr.percent} do not decide
  how many directions should be counted as e.d.r. directions. There information
  depend on users input.
}

\seealso{ \code{\link{double.slice}} \code{\link{cen.sir}} }

\keyword{ utilities }
